models/Productos.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "productos".
 *
 * @property int $idproducto
 * @property string $nombre
 * @property float|null $precioBase
 * @property string|null $fechaPublicacion
 * @property string|null $foto
 * @property int|null $vendido
 * @property string|null $fechaVenta
 * @property int|null $usuarioPublica
 *
 * @property Mensajes[] $mensajes
 * @property Usuarios $usuarioPublica0
 */
class Productos extends \yii\db\ActiveRecord
{
     public $actualizarFoto;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'productos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['nombre'], 'required'],
            [['precioBase'], 'number'],
            [['fechaPublicacion', 'fechaVenta'], 'safe'],
            [['vendido', 'usuarioPublica'], 'integer'],
            [['nombre'], 'string', 'max' => 100],
            [['foto'], 'file', 'skipOnEmpty' => true, 'extensions' => 'png, jpg'],  
            [['usuarioPublica'], 'exist', 'skipOnError' => true, 'targetClass' => Usuarios::className(), 'targetAttribute' => ['usuarioPublica' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'idproducto' => 'Idproducto',
            'nombre' => 'Nombre',
            'precioBase' => 'Precio Base',
            'fechaPublicacion' => 'Fecha Publicacion',
            'foto' => 'Foto',
            'vendido' => 'Vendido',
            'fechaVenta' => 'Fecha Venta',
            'usuarioPublica' => 'Usuario Publica',
        ];
    }

    /**
     * Gets query for [[Mensajes]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getMensajes()
    {
        return $this->hasMany(Mensajes::className(), ['producto' => 'idproducto']);
    }

    /**
     * Gets query for [[UsuarioPublica0]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getUsuarioPublica0()
    {
        return $this->hasOne(Usuarios::className(), ['id' => 'usuarioPublica']);
    }
    
    public function beforeSave($insert) {
        parent::beforeSave($insert);
        
        // poder introducir la fecha en castellano
        if(!empty($this->fechaPublicacion)){
            $this->fechaPublicacion= \DateTime::createFromFormat("d/m/Y", $this->fechaPublicacion)->format("Y/m/d");
        }
        
        if(!empty($this->fechaVenta)){
            $this->fechaVenta= \DateTime::createFromFormat("d/m/Y", $this->fechaVenta)->format("Y/m/d");
        }
        
        
        
        /* tema subida archivos */
        $this->actualizarFoto=TRUE;
        /* si no ha subido ningun fichero recupero el valor anterior de los ficheros */
        if(!isset($this->foto)){
            $this->foto=$this->getOldAttribute("foto");
            $this->actualizarFoto=FALSE;
        }
        
        return true;
        
    }

    public function afterSave($insert, $changeAttributes) {

        /* comprobar si ha seleccionado algun archivo */
        /* ademas comprobamos que sea un fichero lo que me llegue*/
        /* esto es para que si estoy borrando no me de problemas */
        /* llegaria un string en ese caso */
        
        if($this->actualizarFoto && is_object($this->foto)){
            
            // la funcion iconv la utilizo para que saveAs no me de problemas con las tildes y ñ
            $this->foto->saveAs('imgs/id_' . $this->idproducto . '_' . iconv('UTF-8','ISO-8859-1',$this->foto->name), false);
            $this->foto = 'id_' . $this->idproducto . '_' . iconv('UTF-8','ISO-8859-1', $this->foto->name);
        }
        
        //almacenar los cambios
        $this->updateAttributes(["foto"]);
    }
    
    
     public function getFoto() {
       return Yii::$app->request->getBaseUrl() . '/imgs/' . $this->foto;
    }
    
    public function afterFind() {
        parent::afterFind();
        // los listados de fecha me salen en castellano
       
        if(!empty($this->fechaPublicacion)){
            $this->fechaPublicacion=Yii::$app->formatter->asDate($this->fechaPublicacion, 'php:d/m/Y');
        }
        
        if(!empty($this->fechaVenta)){
            $this->fechaVenta=Yii::$app->formatter->asDate($this->fechaVenta, 'php:d/m/Y');
        }
        
    }
    
    public function eliminarFoto(){
        unlink('imgs/' . $this->foto);
        $this->foto="";
        $this->updateAttributes(["foto"]);
        
    }


    
    
}

controllers/ProductosController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Productos;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\web\UploadedFile;
use yii\filters\AccessControl;
use app\models\User;

/**
 * ProductosController implements the CRUD actions for Productos model.
 */
class ProductosController extends Controller
{
    
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['index','view','create','update','delete','eliminar'],
                'rules' => [
                    [
                        'actions' => ['index','view','create','update','delete','eliminar'],
                        'allow' => true,
                        'roles' => ['@'],
                        'matchCallback' => function ($rule, $action) {
                            //Llamada al método que comprueba si es un administrador
                            return User::isUserAdmin(Yii::$app->user->identity->id);
                        },
                        
                    ],
                    
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all Productos models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Productos::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Productos model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Productos model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Productos();

        
        
        if ($model->load(Yii::$app->request->post())) {
            $model->foto = UploadedFile::getInstance($model, 'foto');
            if ($model->save()) {
                return $this->redirect(['view', 'id' => $model->idproducto]);
            }
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Productos model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
        
        if ($model->load(Yii::$app->request->post())) {
            // intentamos recuperar el fichero subido (actualizado)
            // en caso de que no seleccione ninguno el metodo estatico
            // devuelve null
            $model->foto = UploadedFile::getInstance($model, 'foto');

            if ($model->save()) {
                return $this->redirect(['view', 'id' => $model->idproducto]);
            }
        }


        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Productos model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Productos model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Productos the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Productos::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    public function actionEliminar($id){
        $model = $this->findModel($id);
        $model->eliminarFoto();
        return $this->redirect(['view', 'id' => $model->idproducto]);
    }

}

views/productos/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\date\DatePicker;
use yii\bootstrap\Alert;


/* @var $this yii\web\View */
/* @var $model app\models\Productos */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="productos-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'precioBase')->textInput() ?>

    <?php    
    echo '<label class="control-label">Fecha Publicacion</label>';
    echo DatePicker::widget([
        'model' => $model, 
        'attribute' => 'fechaPublicacion',
        'language' => 'es',
        'options' => ['placeholder' => 'Introduce fecha'],
        'pluginOptions' => [
            'todayHighlight' => true,
            'todayBtn' => true,
            'format' => 'dd/mm/yyyy',
            'autoclose' => true,
        ]
    ]);
    ?>


    <?= $form->field($model, 'foto')->fileInput() ?>
    
    <?php
    if (!empty($model->foto)) {
        echo Alert::widget([
            'body' => Html::img($model->getFoto(), [
                'class' => 'img-responsive img-thumbnail',
            ]),
            'closeButton' => [
                'tag' => 'a',
                'href' => \yii\helpers\Url::to(['productos/eliminar', 'id' => $model->idproducto]),
            ],
        ]);
    }
    ?>


    <?= $form->field($model, 'vendido')->textInput() ?>

        
    <?php    
    echo '<label class="control-label">Fecha Venta</label>';
    echo DatePicker::widget([
        'model' => $model, 
        'attribute' => 'fechaVenta',
        'language' => 'es',
        'options' => ['placeholder' => 'Introduce fecha'],
        'pluginOptions' => [
            'todayHighlight' => true,
            'todayBtn' => true,
            'format' => 'dd/mm/yyyy',
            'autoclose' => true,
        ]
    ]);
    ?>

    <?= $form->field($model, 'usuarioPublica')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/productos/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Productos */

$this->title = 'Create Productos';
$this->params['breadcrumbs'][] = ['label' => 'Productos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="productos-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/productos/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Productos';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="productos-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Productos', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'idproducto',
            'nombre',
            'precioBase',
            'fechaPublicacion',
            'foto',
             [
                'label'=>'Imagen del producto',
                'attribute'=>'foto',
                'format'=>'raw',
                'contentOptions'=>['style'=>'text-align:center'],
                'value'=>function($d){
                    return Html::img("@web/imgs/" . $d->foto,['width'=>'100px']);
                }
            ],

            //'vendido',
            //'fechaVenta',
            //'usuarioPublica',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/productos/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Productos */

$this->title = 'Update Productos: ' . $model->idproducto;
$this->params['breadcrumbs'][] = ['label' => 'Productos', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->idproducto, 'url' => ['view', 'id' => $model->idproducto]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="productos-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/productos/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Productos */

$this->title = $model->idproducto;
$this->params['breadcrumbs'][] = ['label' => 'Productos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="productos-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->idproducto], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->idproducto], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'idproducto',
            'nombre',
            'precioBase',
            'fechaPublicacion',
            'foto',
            'vendido',
            'fechaVenta',
            'usuarioPublica',
        ],
    ]) ?>

</div>